Index: sys/kern/kern_mac.c
===================================================================
RCS file: kern_mac.c
diff -N kern_mac.c
--- /dev/null	Fri Sep 21 09:00:02 2001
+++ kern_mac.c	Sun Jun  3 11:28:57 2001
@@ -0,0 +1,459 @@
+/*-
+ * Copyright (c) 1999, 2000 Robert N. M. Watson
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $FreeBSD: $
+ */
+/*
+ * Developed by the TrustedBSD Project.
+ * Userland/kernel interface, policy merging for various access models.
+ */
+
+#include <sys/types.h>
+#include <sys/param.h>
+#include <sys/mac.h>
+#include <sys/mac_private.h>
+#include <sys/proc.h>
+#include <sys/systm.h>
+#include <sys/sysproto.h>
+#include <sys/sysent.h>
+#include <sys/vnode.h>
+#include <sys/file.h>
+#include <sys/namei.h>
+#include <sys/sysctl.h>
+
+#include "opt_mac.h"
+
+#ifdef MAC
+
+/*
+ * Given an operation and optional sub_operation, return 0 if it is
+ * permitted by the MAC labels and policies, and an errno value
+ * otherwise.
+ */
+int
+mac_can(const struct ucred *cred, const struct mac *label, int operation,
+    int sub_operation)
+{
+	int error;
+
+	/*
+	 * Only allow the operation if all of our sub-policies also
+	 * permits the operation.
+	 */
+	if ((error = mac_biba_can(cred, label, operation, sub_operation))) {
+		printf("mac_biba_can forbids action\n");
+		return (error);
+	}
+	if ((error = mac_mls_can(cred, label, operation, sub_operation))) {
+		printf("mac_mls_can forbids action\n");
+		return (error);
+	}
+	if ((error = mac_partition_can(cred, label, operation,
+	    sub_operation))) {
+		printf("mac_partition_can forbids action\n");
+		return (error);
+	}
+
+	return (0);
+}
+
+#if 0
+/*
+ * POSIX.1e calls for a dominate function to be exported or available
+ * to userland processes.  However, not all policies support a concept
+ * of "dominate" and so it may be inappropriate in more general policy
+ * environments (such as type enforcement).  Disabled for the time
+ * being in the hopes that it doesn't prove necessary.
+ */
+/*
+ * Return (1) if MAC labela dominates MAC labelb, otherwise, (0).
+ */
+int
+mac_dominate(const struct mac *labela, const struct mac *labelb)
+{
+
+	/*
+	 * A MAC label only dominates another if all of the component
+	 * labels from it dominate the other.
+	 */
+	return (mac_biba_dominate(&labela->m_biba, &labelb->m_biba) &&
+	    mac_mls_dominate(&labela->m_mls, &labelb->m_mls) &&
+	    mac_partition_dominate(&labela->m_partition,
+	    &labelb->m_partition));
+}
+#endif
+
+/*
+ * Return (1) if the two MAC labels are equal, otherwise, (0).
+ */
+int
+mac_equal(const struct mac *labela, const struct mac *labelb)
+{
+
+	/*
+	 * Two MAC labels are only equal of they are equal according to
+	 * all of the individual policies.
+	 */
+	return (mac_biba_equal(labela, labelb) &&
+	    mac_mls_equal(labela, labelb) &&
+	    mac_partition_equal(labela, labelb));
+}
+
+/*
+ * At system start-up time, the credential of the first-born process
+ * is passed in for label initialization.  What actually occurs will
+ * be policy-specific, but the results should allow the system to
+ * boot.
+ */
+void
+mac_init_subject(struct ucred *cred)
+{
+
+	mac_biba_init_subject(cred);
+	mac_mls_init_subject(cred);
+	mac_partition_init_subject(cred);
+}
+
+/*
+ * When a new process is created, its label must be initialized.  Generally,
+ * this involves inheritence from the parent process, modulo possible
+ * deltas.  This function allows that processing to take place.
+ */
+void
+mac_create_subject(const struct ucred *parent_cred,
+    struct ucred *child_cred)
+{
+
+	mac_biba_create_subject(parent_cred, child_cred);
+	mac_mls_create_subject(parent_cred, child_cred);
+	mac_partition_create_subject(parent_cred, child_cred);
+}
+
+/*
+ * Processes may need to modify their current subject label if they
+ * perform multi-level activities, or proxy data between levels.
+ * This function is a check to determine if a particular label change
+ * is permitted; the old and new credentials are provided.  0 is
+ * returned for success, otherwise an errno.
+ */
+int
+mac_can_setlabel_subject(const struct ucred *cred_old,
+    const struct ucred *cred_new)
+{
+	int error;
+
+	/*
+	 * Because a composition occurs here, we must select one
+	 * error to return to the user.  A precedence rule should
+	 * probably be present, but instead we return the first
+	 * failure to be discovered.  Any failure by any policy
+	 * vetoes the whole operation.
+	 */
+
+	error = mac_biba_can_setlabel_subject(cred_old, cred_new);
+	if (error)
+		return (error);
+
+	error = mac_mls_can_setlabel_subject(cred_old, cred_new);
+	if (error)
+		return (error);
+
+	error = mac_partition_can_setlabel_subject(cred_old, cred_new);
+	if (error)
+		return (error);
+
+	return (0);
+}
+
+/*
+ * Generally speaking, object providers will maintain persistent or
+ * inherited labels for most system objects.  However, until this
+ * is done, mac_init_object() will be used to label unlabeled objects.
+ * For safety purposes, this should protect the object from unnecessary
+ * writes, and possibly reads.
+ */
+void
+mac_init_object(struct mac *label)
+{
+
+	mac_biba_init_object(label);
+	mac_mls_init_object(label);
+	mac_partition_init_object(label);
+}
+
+/*
+ * When a new object is created, its label must be initialized.  Generally,
+ * this involves inheritence from the subject creating the object,
+ * modulo possible deltas.  This function allows that processing to take
+ * place.
+ */
+void
+mac_create_object(const struct ucred *cred, struct mac *label)
+{
+
+	if (cred != NULL) {
+		mac_biba_create_object(cred, label);
+		mac_mls_create_object(cred, label);
+		mac_partition_create_object(cred, label);
+	} else
+		mac_init_object(label);
+}
+
+/*
+ * Processes may need to modify the current object label on objects in
+ * the system, for reasons identified above.  This function is a check to
+ * determine if a particular label change is permitted; the requesting
+ * credential is provided, as well as the old and new object labels.  0 is
+ * returned for success, otherwise an errno.
+ */
+int
+mac_can_setlabel_object(const struct ucred *cred, const struct mac *label_old,
+    const struct mac *label_new)
+{
+	int error;
+
+	/*
+	 * Because a composition occurs here, we must select one
+	 * error to return to the user.  A precedence rule should
+	 * probably be present, but instead we return the first
+	 * failure to be discovered.  Any failure by any policy
+	 * vetoes the whole operation.
+	 */
+
+	error = mac_biba_can_setlabel_object(cred, label_old, label_new);
+	if (error)
+		return (error);
+
+	error = mac_mls_can_setlabel_object(cred, label_old, label_new);
+	if (error)
+		return (error);
+
+	error = mac_partition_can_setlabel_object(cred, label_old, label_new);
+	if (error)
+		return (error);
+
+	return (0);
+}
+
+void
+mac_print_label(const struct mac *label)
+{
+
+	printf("MAC label:\n");
+	mac_biba_print_label(label);
+	mac_mls_print_label(label);
+	mac_partition_print_label(label);
+}
+
+/*
+ * Function to intersect with vaccess() providing mandatory access
+ * checks for file system objects.  Accepts object type, object label,
+ * access request, requesting credential, and an optional privused
+ * field to return privilege information (currently unused).
+ */
+int
+vaccess_mac(enum vtype type, const struct mac *filelabel, mode_t acc_mode,
+    struct ucred *cred, int *privused)
+{
+	int error = 0;
+
+	/* Detect and reject unknown access modes. */
+	if (acc_mode & (VWRITE | VADMIN | VREAD | VEXEC) != acc_mode) {
+		printf("vaccess_mac: unknown access mode in %d\n", acc_mode);
+		return (EPERM);
+	}
+
+	if (acc_mode & VWRITE) {
+		error = mac_can(cred, filelabel, MAC_WRITE, 0);
+		if (error != 0)
+			return (error);
+	}
+
+	if (acc_mode & VADMIN) {
+		error = mac_can(cred, filelabel, MAC_ADMIN, 0);
+		if (error != 0)
+			return (error);
+	}
+
+	if (acc_mode & VREAD) {
+		error = mac_can(cred, filelabel, MAC_READ, 0);
+		if (error != 0)
+			return (error);
+	}
+
+	if (acc_mode & VEXEC) {
+		error = mac_can(cred, filelabel, MAC_EXEC, 0);
+		if (error != 0)
+			return (error);
+	}
+
+	return (0);
+}
+
+int
+__mac_get_proc(struct proc *p, struct __mac_get_proc_args *uap)
+{
+	int error;
+
+	error = copyout(&p->p_ucred->cr_label, SCARG(uap, mac_p),
+	    sizeof(p->p_ucred->cr_label));
+
+	return (0);
+}
+
+int
+__mac_set_proc(struct proc *p, struct __mac_set_proc_args *uap)
+{
+	struct ucred *new_cred, *old_cred;
+	int error;
+
+	old_cred = p->p_ucred;
+	new_cred = crdup(p->p_ucred);
+	if (new_cred == NULL)
+		return (ENOMEM);
+
+	error = copyin(SCARG(uap, mac_p), &new_cred->cr_label,
+	    sizeof(new_cred->cr_label));
+	if (error) {
+		crfree(new_cred);
+		return (error);
+	}
+
+	error = mac_can_setlabel_subject(p->p_ucred, new_cred);
+	if (error) {
+		crfree(new_cred);
+		return (error);
+	}
+
+	p->p_ucred = new_cred;
+	crfree(old_cred);
+	return (0);
+}
+
+int
+__mac_get_fd(struct proc *p, struct __mac_get_fd_args *uap)
+{
+
+	return (ENOSYS);
+}
+
+int
+__mac_get_file(struct proc *p, struct __mac_get_file_args *uap)
+{
+	struct nameidata nd;
+	struct mac label;
+	int error;
+
+	NDINIT(&nd, LOOKUP, LOCKLEAF | FOLLOW, UIO_USERSPACE,
+	    SCARG(uap, path_p), p);
+	error = namei(&nd);
+	if (error)
+		return (error);
+
+	error = VOP_GETLABEL(nd.ni_vp, &label, p->p_ucred, p);
+	NDFREE(&nd, 0);
+	if (error)
+		return (error);
+
+	error = copyout(&label, SCARG(uap, mac_p), sizeof(label));
+
+	return (error);
+}
+
+int
+__mac_set_fd(struct proc *p, struct __mac_set_fd_args *uap)
+{
+
+	return (ENOSYS);
+}
+
+int
+__mac_set_file(struct proc *p, struct __mac_set_file_args *uap)
+{
+	struct nameidata nd;
+	struct mac label;
+	int error;
+
+	error = copyin(SCARG(uap, mac_p), &label, sizeof(label));
+	if (error)
+		return (error);
+
+	NDINIT(&nd, LOOKUP, LOCKLEAF | FOLLOW, UIO_USERSPACE,
+	    SCARG(uap, path_p), p);
+	error = namei(&nd);
+	if (error)
+		return (error);
+
+	error = VOP_SETLABEL(nd.ni_vp, &label, p->p_ucred, p);
+	NDFREE(&nd, 0);
+
+	return (error);
+}
+
+#else /* !MAC */
+
+int
+__mac_get_proc(struct proc *p, struct __mac_get_proc_args *uap)
+{
+
+	return (ENOSYS);
+}
+
+int
+__mac_set_proc(struct proc *p, struct __mac_set_proc_args *uap)
+{
+
+	return (ENOSYS);
+}
+
+int
+__mac_get_fd(struct proc *p, struct __mac_get_fd_args *uap)
+{
+
+	return (ENOSYS);
+}
+
+int
+__mac_get_file(struct proc *p, struct __mac_get_file_args *uap)
+{
+
+	return (ENOSYS);
+}
+
+int
+__mac_set_fd(struct proc *p, struct __mac_set_fd_args *uap)
+{
+
+	return (ENOSYS);
+}
+
+int
+__mac_set_file(struct proc *p, struct __mac_set_file_args *uap)
+{
+
+	return (ENOSYS);
+}
+
+#endif /* !MAC */
Index: sys/kern/kern_mac_biba.c
===================================================================
RCS file: kern_mac_biba.c
diff -N kern_mac_biba.c
--- /dev/null	Fri Sep 21 09:00:02 2001
+++ kern_mac_biba.c	Sun Nov 19 17:56:28 2000
@@ -0,0 +1,250 @@
+/*-
+ * Copyright (c) 1999, 2000 Robert N. M. Watson
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $FreeBSD: $
+ */
+/*
+ * Developed by the TrustedBSD Project.
+ * Biba Integrity Policy.
+ */
+
+#include <sys/types.h>
+#include <sys/param.h>
+#include <sys/mac.h>
+#include <sys/mac_private.h>
+#include <sys/proc.h>
+#include <sys/systm.h>
+#include <sys/sysproto.h>
+#include <sys/sysent.h>
+#include <sys/vnode.h>
+#include <sys/file.h>
+#include <sys/sysctl.h>
+
+#include "opt_mac.h"
+
+#ifdef MAC
+
+/*
+ * Syntactic check of label: 0 for success, else an errno.
+ */
+static int
+mac_biba_label_valid(const struct mac *label)
+{
+
+	switch(label->m_biba.mb_type) {
+	case MAC_BIBA_TYPE_GRADE:
+		break;
+	case MAC_BIBA_TYPE_HIGH:
+	case MAC_BIBA_TYPE_LOW:
+	case MAC_BIBA_TYPE_EQUAL:
+		if (label->m_biba.mb_grade != 0)
+			return (EINVAL);
+		break;
+	default:
+		return (EINVAL);
+	}
+
+	return (0);
+}
+
+int
+mac_biba_can(const struct ucred *cred, const struct mac *label, int operation,
+    int sub_operation)
+{
+	/*
+	 * Biba integrity policy dictates that for a subject to modify
+	 * an object, the label on the subject most dominate that of the
+	 * object.  The policy dictates that for a subject to read an
+	 * object, the label of the object must dominate that of the
+	 * subject.  For a subject to create an object on a fixed-label
+	 * target, the label of the subject must equal the label of the
+	 * target.  Appropriate privilege can override Biba protection.
+	 *
+	 * MAC_WRITE, MAC_ADMIN, MAC_SIGNAL: subject dominates object
+	 * MAC_READ, MAC_EXEC, MAC_STAT: object dominates subject
+	 * MAC_CREATE: subject equals object
+	 */
+	if (operation & (MAC_WRITE | MAC_ADMIN | MAC_SIGNAL) &&
+	    !mac_biba_dominate(&cred->cr_label, label) &&
+	    suser_xxx(cred, NULL, 0))
+		return (EACCES);
+
+	if (operation & (MAC_READ | MAC_EXEC | MAC_STAT) &&
+	    !mac_biba_dominate(label, &cred->cr_label) &&
+	    suser_xxx(cred, NULL, 0))
+		return (EACCES);
+
+	if (operation & MAC_CREATE &&
+	    !mac_biba_equal(&cred->cr_label, label) &&
+	    suser_xxx(cred, NULL, 0))
+		return (EACCES);
+
+	return (0);
+}
+
+int
+mac_biba_dominate(const struct mac *labela, const struct mac *labelb)
+{
+
+	switch (labela->m_biba.mb_type) {
+	case MAC_BIBA_TYPE_GRADE:
+		switch (labelb->m_biba.mb_type) {
+		case MAC_BIBA_TYPE_GRADE:
+			return (labela->m_biba.mb_grade >=
+			    labelb->m_biba.mb_grade);
+
+		case MAC_BIBA_TYPE_LOW:
+			return (1);
+
+		case MAC_BIBA_TYPE_HIGH:
+			return (0);
+
+		case MAC_BIBA_TYPE_EQUAL:
+			return (1);
+
+		default:
+			panic("mac_biba_dominate(): unknown mb_type\n");
+		}
+
+	case MAC_BIBA_TYPE_LOW:
+		switch (labelb->m_biba.mb_type) {
+		case MAC_BIBA_TYPE_GRADE:
+			return (0);
+
+		case MAC_BIBA_TYPE_LOW:
+			return (1);
+
+		case MAC_BIBA_TYPE_HIGH:
+			return (0);
+
+		case MAC_BIBA_TYPE_EQUAL:
+			return (1);
+
+		default:
+			panic("mac_biba_dominate(): unknown mb_type\n");
+		}
+
+	case MAC_BIBA_TYPE_HIGH:
+		return (1);
+
+	case MAC_BIBA_TYPE_EQUAL:
+		return (1);
+	default:
+		panic("mac_biba_dominate(): unknown mb_type\n");
+	}
+}
+
+int
+mac_biba_equal(const struct mac *labela, const struct mac *labelb)
+{
+
+	return (mac_biba_dominate(labela, labelb) &&
+	    mac_biba_dominate(labelb, labela));
+}
+
+void
+mac_biba_init_subject(struct ucred *cred)
+{
+
+	/*
+	 * Early system processes run with high integrity.
+	 */
+	cred->cr_label.m_biba.mb_type = MAC_BIBA_TYPE_HIGH;
+	cred->cr_label.m_biba.mb_grade = 0;
+}
+
+void
+mac_biba_create_subject(const struct ucred *cred_parent,
+    struct ucred *cred_child)
+{
+
+	cred_child->cr_label = cred_parent->cr_label;
+}
+
+int
+mac_biba_can_setlabel_subject(const struct ucred *cred_old,
+    const struct ucred *cred_new)
+{
+	int error;
+
+	error = mac_biba_label_valid(&cred_new->cr_label);
+	if (error)
+		return (error);
+
+	error = suser_xxx(cred_old, NULL, 0);
+	if (error)
+		return (error);
+
+	return (0);
+}
+
+void
+mac_biba_init_object(struct mac *label)
+{
+
+	/*
+	 * XXX:
+	 * Eventually, objects without explicit labeling will be at
+	 * low integrity.  For development purposes, set them to high
+	 * integrity to allow the system to boot.
+	 */
+	label->m_biba.mb_type = MAC_BIBA_TYPE_HIGH;
+	label->m_biba.mb_grade = 0;
+}
+
+void
+mac_biba_create_object(const struct ucred *cred, struct mac *label)
+{
+
+	label->m_biba.mb_type = cred->cr_label.m_biba.mb_type;
+	label->m_biba.mb_grade = cred->cr_label.m_biba.mb_grade;
+}
+
+int
+mac_biba_can_setlabel_object(const struct ucred *cred,
+    const struct mac *label_old, const struct mac *label_new)
+{
+	int error;
+
+	error = mac_biba_label_valid(label_new);
+	if (error)
+		return (error);
+
+	error = suser_xxx(cred, NULL, 0);
+	if (error)
+		return (error);
+
+	return (0);
+}
+
+void
+mac_biba_print_label(const struct mac *label)
+{
+
+	printf("Biba: type==%u, grade==%u\n", label->m_biba.mb_type,
+	    label->m_biba.mb_grade);
+}
+
+#endif /* !MAC */
Index: sys/kern/kern_mac_mls.c
===================================================================
RCS file: kern_mac_mls.c
diff -N kern_mac_mls.c
--- /dev/null	Fri Sep 21 09:00:02 2001
+++ kern_mac_mls.c	Sun Nov 19 17:56:28 2000
@@ -0,0 +1,252 @@
+/*-
+ * Copyright (c) 1999, 2000 Robert N. M. Watson
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $FreeBSD: $
+ */
+/*
+ * Developed by the TrustedBSD Project.
+ * Multi-Level Security Policy.
+ */
+
+#include <sys/types.h>
+#include <sys/param.h>
+#include <sys/mac.h>
+#include <sys/mac_private.h>
+#include <sys/proc.h>
+#include <sys/systm.h>
+#include <sys/sysproto.h>
+#include <sys/sysent.h>
+#include <sys/vnode.h>
+#include <sys/file.h>
+#include <sys/sysctl.h>
+
+#include "opt_mac.h"
+
+#ifdef MAC
+
+/*
+ * Syntactic check of label: 0 for success, else an errno.
+ */
+static int
+mac_mls_label_valid(const struct mac *label)
+{
+  
+	switch(label->m_mls.mm_type) {
+	case MAC_MLS_TYPE_LEVEL:
+		break;
+	case MAC_MLS_TYPE_HIGH:
+	case MAC_MLS_TYPE_LOW:
+	case MAC_MLS_TYPE_EQUAL:
+		if (label->m_mls.mm_level != 0)
+			return (EINVAL);
+		break;
+	default:
+		return (EINVAL);
+	}
+
+	return (0);
+}
+
+int
+mac_mls_can(const struct ucred *cred, const struct mac *label, int operation,
+    int sub_operation)
+{
+	/*
+	 * POSIX.1e FP.2: The MAC label of a file shall dominate the MAC
+	 * label of a subject for the subject to write the data or the
+	 * attributes of a file.
+	 * POSIX.1e FP.1: The MAC label of a file shall be dominated by the
+	 * MAC label of the subject for the subject to read the data or
+	 * attributes of a file.
+	 * To create an object on a fixed-label target, the label of the
+	 * subject must equal that of the target.
+	 *
+	 * MAC_WRITE, MAC_ADMIN, MAC_SIGNAL: object dominates subject
+	 * MAC_READ, MAC_EXEC, MAC_STAT: subject dominates object
+	 * MAC_REATE: subject equals object
+	 */
+	if (operation & (MAC_WRITE | MAC_ADMIN | MAC_SIGNAL) &&
+	    !mac_mls_dominate(label, &cred->cr_label) &&
+	    suser_xxx(cred, NULL, 0))
+		return (EACCES);
+	if (operation & (MAC_READ | MAC_EXEC | MAC_STAT) &&
+	    !mac_mls_dominate(&cred->cr_label, label) &&
+	    suser_xxx(cred, NULL, 0))
+		return (EACCES);
+	if (operation & MAC_CREATE &&
+	    !mac_mls_equal(&cred->cr_label, label) &&
+	    suser_xxx(cred, NULL, 0))
+		return (EACCES);
+
+	return (0);
+}
+
+int
+mac_mls_dominate(const struct mac *labela, const struct mac *labelb)
+{
+
+	switch (labela->m_mls.mm_type) {
+	case MAC_MLS_TYPE_LEVEL:
+		switch (labelb->m_mls.mm_type) {
+		case MAC_MLS_TYPE_LEVEL:
+			return (labela->m_mls.mm_level >=
+			    labelb->m_mls.mm_level);
+
+		case MAC_MLS_TYPE_LOW:
+			return (1);
+
+		case MAC_MLS_TYPE_HIGH:
+			return (0);
+
+		case MAC_MLS_TYPE_EQUAL:
+			return (1);
+
+		default:
+			panic("mac_mls_dominate(): Unknown mm_type\n");
+		}
+
+	case MAC_MLS_TYPE_LOW:
+		switch (labelb->m_mls.mm_type) {
+		case MAC_MLS_TYPE_LEVEL:
+			return (0);
+
+		case MAC_MLS_TYPE_LOW:
+			return (1);
+
+		case MAC_MLS_TYPE_HIGH:
+			return (0);
+
+		case MAC_MLS_TYPE_EQUAL:
+			return (1);
+
+		default:
+			panic("mac_mls_dominate(): Unknown mm_type\n");
+		}
+
+	case MAC_MLS_TYPE_HIGH:
+		return (1);
+
+	case MAC_MLS_TYPE_EQUAL:
+		return (1);
+
+	default:
+		panic("mac_mls_dominate(): Unknown mm_type\n");
+	}
+	return (0);
+}
+
+int
+mac_mls_equal(const struct mac *labela, const struct mac *labelb)
+{
+
+	return (mac_mls_dominate(labela, labelb) &&
+	    mac_mls_dominate(labelb, labela));
+}
+
+void
+mac_mls_init_subject(struct ucred *cred)
+{
+
+	/*
+	 * Early system processes run with low secrecy, and must
+	 * use privilege to access high secrecy objects.
+	 */
+	cred->cr_label.m_mls.mm_type = MAC_MLS_TYPE_LOW;
+	cred->cr_label.m_mls.mm_level = 0;
+}
+
+void
+mac_mls_create_subject(const struct ucred *cred_parent,
+    struct ucred *cred_child)
+{
+
+	cred_child->cr_label = cred_parent->cr_label;
+}
+
+int
+mac_mls_can_setlabel_subject(const struct ucred *cred_old,
+    const struct ucred *cred_new)
+{
+	int error;
+
+	error = mac_mls_label_valid(&cred_new->cr_label);
+	if (error)
+		return (error);
+
+	error = suser_xxx(cred_old, NULL, 0);
+	if (error)
+		return (error);
+
+	return (0);
+}
+
+void
+mac_mls_init_object(struct mac *label)
+{
+
+	/*
+	 * XXX:
+	 * Eventually, might be desirable to label unlabeled objects
+	 * as high secrecy, but for initial booting purposes, label
+	 * them as low secrecy.
+	 */
+	label->m_mls.mm_type = MAC_MLS_TYPE_LOW;
+	label->m_mls.mm_level = 0;
+}
+
+void
+mac_mls_create_object(const struct ucred *cred, struct mac *label)
+{
+
+	label->m_mls.mm_type = cred->cr_label.m_mls.mm_type;
+	label->m_mls.mm_level = cred->cr_label.m_mls.mm_level;
+}
+
+int
+mac_mls_can_setlabel_object(const struct ucred *cred,
+    const struct mac *label_old, const struct mac *label_new)
+{
+	int error;
+
+	error = mac_mls_label_valid(label_new);
+	if (error)
+		return (error);
+
+	error = suser_xxx(cred, NULL, 0);
+	if (error)
+		return (error);
+
+	return (0);
+}
+
+void
+mac_mls_print_label(const struct mac *label)
+{
+
+	printf("MLS: type==%u, level==%u\n", label->m_mls.mm_type,
+	    label->m_mls.mm_level);
+}
+
+#endif /* !MAC */
Index: sys/kern/kern_mac_partition.c
===================================================================
RCS file: kern_mac_partition.c
diff -N kern_mac_partition.c
--- /dev/null	Fri Sep 21 09:00:02 2001
+++ kern_mac_partition.c	Sun Nov 19 17:56:28 2000
@@ -0,0 +1,227 @@
+/*-
+ * Copyright (c) 1999, 2000 Robert N. M. Watson
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $FreeBSD: $
+ */
+/*
+ * Developed by the TrustedBSD Project.
+ * Light-Weight Partition Policy.
+ */
+
+#include <sys/types.h>
+#include <sys/param.h>
+#include <sys/mac.h>
+#include <sys/mac_private.h>
+#include <sys/proc.h>
+#include <sys/systm.h>
+#include <sys/sysproto.h>
+#include <sys/sysent.h>
+#include <sys/vnode.h>
+#include <sys/file.h>
+#include <sys/sysctl.h>
+
+#include "opt_mac.h"
+
+#ifdef MAC
+
+/*
+ * Syntactic check of label: 0 for success, else an errno.
+ */
+static int
+mac_partition_label_valid(const struct mac *label)
+{
+  
+	switch(label->m_partition.mp_type) {
+	case MAC_PARTITION_TYPE_PARTITION:
+		break;
+	case MAC_PARTITION_TYPE_NONE:
+	case MAC_PARTITION_TYPE_ALL:
+		if (label->m_partition.mp_partition != 0)
+			return (EINVAL);
+		break;
+	default:
+		return (EINVAL);
+	}
+
+	return (0);
+}
+
+int
+mac_partition_can(const struct ucred *cred, const struct mac *label,
+    int operation, int sub_operation)
+{
+	/*
+	 * Partitioning policy dictates that for a subject to modify
+	 * an object, the label of the subject must dominate that of the
+	 * object.
+	 * For a subject to read an object, the label of the subject must
+	 * dominate the label of the object.
+         * For a subject to create an object on a fixed-label target, the
+	 * label of the subject must dominate the label of the target.
+	 * Appropriate privilege may override the Partition policy.
+	 *
+	 * MAC_WRITE, MAC_ADMIN, MAC_SIGNAL: subject dominates object
+	 * MAC_READ, MAC_EXEC, MAC_STAT: subject dominates object
+	 * MAC_CREATE: subject dominates object
+	 */
+	if (operation & MAC_ALL &&
+	    !mac_partition_dominate(&cred->cr_label, label) &&
+	    suser_xxx(cred, NULL, 0))
+		return (EACCES);
+
+	return (0);
+}
+
+int
+mac_partition_dominate(const struct mac *labela, const struct mac *labelb)
+{
+
+	switch(labela->m_partition.mp_type) {
+	case MAC_PARTITION_TYPE_PARTITION:
+		switch(labelb->m_partition.mp_type) {
+		case MAC_PARTITION_TYPE_PARTITION:
+			return (labela->m_partition.mp_partition ==
+			    labelb->m_partition.mp_partition);
+
+		case MAC_PARTITION_TYPE_ALL:
+			/*
+			 * Bypass of this restriction for MAC_READ
+			 * is implemented in mac_partition_can().
+			 */
+			return (0);
+
+		case MAC_PARTITION_TYPE_NONE:
+			return (0);
+
+		default:
+			panic("mac_partition_dominate(): Unknown mp_type\n");
+		}
+
+	case MAC_PARTITION_TYPE_ALL:
+		printf("mac_partition_dominate: warning, "
+		    "MAC_PARTITION_TYPE_ALL used as subject.");
+		return (labelb->m_partition.mp_type == MAC_PARTITION_TYPE_ALL);
+
+	case MAC_PARTITION_TYPE_NONE:
+		return (1);
+
+	default:
+		panic("mac_partition_dominate(): Unknown mp_type\n");
+	}
+
+	return (0);
+}
+
+int
+mac_partition_equal(const struct mac *labela, const struct mac *labelb)
+{
+
+	return (mac_partition_dominate(labela, labelb) &&
+	    mac_partition_dominate(labelb, labela));
+}
+
+void
+mac_partition_init_subject(struct ucred *cred)
+{
+
+	/*
+	 * Early system processes run outside of partitions.
+	 */
+	cred->cr_label.m_partition.mp_type = MAC_PARTITION_TYPE_NONE;
+	cred->cr_label.m_partition.mp_partition = 0;
+}
+
+void
+mac_partition_create_subject(const struct ucred *cred_parent,
+    struct ucred *cred_child)
+{
+
+	cred_child->cr_label = cred_parent->cr_label;
+}
+
+int
+mac_partition_can_setlabel_subject(const struct ucred *cred_old,
+    const struct ucred *cred_new)
+{
+	int error;
+
+	error = mac_partition_label_valid(&cred_new->cr_label);
+	if (error)
+		return (error);  
+
+	error = suser_xxx(cred_old, NULL, 0);
+	if (error)
+		return (error);
+
+	return (0);
+}
+
+void
+mac_partition_init_object(struct mac *label)
+{
+
+	/*
+	 * Unless explicitely labeled, objects are not visible from
+	 * any partition.
+	 */
+	label->m_partition.mp_type = MAC_PARTITION_TYPE_NONE;
+	label->m_partition.mp_partition = 0;
+}
+
+void
+mac_partition_create_object(const struct ucred *cred, struct mac *label)
+{
+
+	label->m_partition.mp_type = cred->cr_label.m_partition.mp_type;
+	label->m_partition.mp_partition =
+	    cred->cr_label.m_partition.mp_partition;
+}
+
+int
+mac_partition_can_setlabel_object(const struct ucred *cred,
+    const struct mac *label_old, const struct mac *label_new)
+{
+	int error;
+
+	error = mac_partition_label_valid(label_new);
+	if (error)
+		return (error);
+
+	error = suser_xxx(cred, NULL, 0);
+	if (error)
+		return (error);
+
+	return (0);
+}
+
+void
+mac_partition_print_label(const struct mac *label)
+{
+
+	printf("Partition: type==%u, partition==%u\n",
+	    label->m_partition.mp_type, label->m_partition.mp_partition);
+}
+
+#endif /* !MAC */
